/*
 * Created on 15.09.2004 by laliluna
 *
 */
package de.laliluna.dynamicForms.decoratorExample;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

import org.apache.commons.collections.Factory;
import org.apache.commons.collections.list.LazyList;

import de.laliluna.dynamicForms.struts.form.Apple;


/**
 * @author laliluna
 * www.laliluna.de
 * example for a decorator which could be used as a solution to the indexOutOfBounds problem with dynamic forms.
 * There are no checks for nothing!
 * This class only shows the technology. 
 * You should consider to use the LazyList class from the Common Collections package
 * from http://jakarta.apache.org  
 */
public class DecoratorExample implements List {

    /**  the factory creating new instances of the class which are included in the list    */
    private ObjectFactory objectFactory;
    
    /** our list holding the values */
    private List list;
    
    

    private DecoratorExample(List list, ObjectFactory objectFactory){
        this.list = list;
        this.objectFactory = objectFactory;
    }
    
    /** function to be used to get a new instance from the decorator */
    public static List getInstance(List list, ObjectFactory objectFactory){
        return new DecoratorExample(list, objectFactory);
    }

    /*
     * HS 15.09.2004
     * our decorated function with new special features
     *
     */
    public Object get(int index) {
        // HS 15.09.2004 when the list is to short, create new entries and initalize them
        while (index >= list.size())
            list.add(objectFactory.create());
        
        return list.get(index);
    }
    
    /*
     * HS 15.09.2004
     * from here just delegate methods to the list
     *
     */
    public void add(int index, Object element) {
        list.add(index, element);
    }
    public boolean add(Object o) {
        return list.add(o);
    }
    public boolean addAll(int index, Collection c) {
        return list.addAll(index, c);
    }
    public boolean addAll(Collection c) {
        return list.addAll(c);
    }
    public void clear() {
        list.clear();
    }
    public boolean contains(Object o) {
        return list.contains(o);
    }
    public boolean containsAll(Collection c) {
        return list.containsAll(c);
    }
    public boolean equals(Object obj) {
        return list.equals(obj);
    }

    public int hashCode() {
        return list.hashCode();
    }
    public int indexOf(Object o) {
        return list.indexOf(o);
    }
    public boolean isEmpty() {
        return list.isEmpty();
    }
    public Iterator iterator() {
        return list.iterator();
    }
    public int lastIndexOf(Object o) {
        return list.lastIndexOf(o);
    }
    public ListIterator listIterator() {
        return list.listIterator();
    }
    public ListIterator listIterator(int index) {
        return list.listIterator(index);
    }
    public Object remove(int index) {
        return list.remove(index);
    }
    public boolean remove(Object o) {
        return list.remove(o);
    }
    public boolean removeAll(Collection c) {
        return list.removeAll(c);
    }
    public boolean retainAll(Collection c) {
        return list.retainAll(c);
    }
    public Object set(int index, Object element) {
        return list.set(index, element);
    }
    public int size() {
        return list.size();
    }
    public List subList(int fromIndex, int toIndex) {
        return list.subList(fromIndex, toIndex);
    }
    public Object[] toArray() {
        return list.toArray();
    }
    public Object[] toArray(Object[] a) {
        return list.toArray(a);
    }
    public String toString() {
        return list.toString();
    }
}
