/*
 * Created on 13.09.2004 by laliluna
 *
 */
package de.laliluna.dynamicForms.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.laliluna.dynamicForms.struts.form.Apple;
import de.laliluna.dynamicForms.struts.form.ApplesForm;
import de.laliluna.dynamicForms.struts.form.NestedApplesForm;

/**
 * @author laliluna
 *  Example using a list decorator to prevent a ArrayIndexOutOfBoundsException or IndexOutOfBoundsException 
 *  
 */
public class NestedAppleAction extends Action {

    /*
     * (non-Javadoc)
     * 
     * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping,
     *             org.apache.struts.action.ActionForm,
     *             javax.servlet.http.HttpServletRequest,
     *             javax.servlet.http.HttpServletResponse)
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        System.out.println("" + this.getClass() + ".execute");

        // HS 13.09.2004 check if form is null and create new form and save it
        // in the request (this is not beautiful, but unimportant for the
        // tutorial)
        NestedApplesForm applesForm;
        if (form == null) {
            applesForm = new NestedApplesForm();
            request.setAttribute(mapping.getAttribute(), applesForm);
        } else
            applesForm = (NestedApplesForm) form;

        // HS 13.09.2004 when init is parameter, create some dummy apples
        // data
        if (request.getParameter("init") != null) {
            System.out.println("creating dummy entries");
            String names[] = { "Boskop", "Golden Renette", "Kaiser Wilhelm" };
            String sizes[] = { "big", "middle", "small" };
            for (int i = 0; i < sizes.length; i++) {
                applesForm.getApples().add(new Apple(names[i], sizes[i]));

            }
        }

        /*
         * HS 13.09.2004 when delete exists, the delete button has been clicked
         *  
         */
        if (request.getParameter("delete") != null) {
            System.out.println("Deleting");
            if (applesForm.getApples().size() > 0)
                    applesForm.getApples().remove(0);
        }

        return mapping.findForward("success");
    }
}