/*
 * Created on 12.09.2004 by laliluna
 *
 */
package de.laliluna.dynamicForms.struts.form;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.collections.Factory;
import org.apache.commons.collections.list.LazyList;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

/**
 * @author laliluna
 *  Example using a list decorator to prevent a ArrayIndexOutOfBoundsException or IndexOutOfBoundsException 
 */
public class NestedApplesForm extends ActionForm {

    /** our List of apples*/
    private List apples;
    
    /**
     * constructor initializing the apples with a decorated list (LazyList). 
     * This is only needed in case when you create a form and don't call reset for initialization.
     *
     */
    public NestedApplesForm() {
        Factory factory = new Factory() {

            public Object create() {
                return new Apple();
            }
        };
        apples = LazyList.decorate(new ArrayList(), factory);
    }

    

    /**
     * @return Returns the apples.
     */
    public List getApples() {
        return apples;
    }

 /**
  *  resets the apples List and decorates it with a LazyList to prevent an indexOutOfBoundsException
  */
    public void reset(ActionMapping arg0, HttpServletRequest arg1) {
        System.out.println("resetting NestedApplesForm");
        Factory factory = new Factory() {

            public Object create() {
                return new Apple();
            }
        };

        apples = LazyList.decorate(new ArrayList(), factory);
    }
}